//Kostas Anagnostou - Ionio University - Department Of Computer Science
//Computer Graphics - Lab 3

#include <GL/glut.h>// OpenGL toolkit

#include <stdlib.h>
#include <math.h>

//Εδώ ορίζουμε το μέγεθος του παραθύρου στην οθόνη του υπολογιστή μας
const int Width = 1024;
const int Height = 768;
//Αν είναι η DrawAxis είναι 1 ζωγραφίζουμε το σύστημα αξόνων
int DrawAxis = 0;
//Αν είναι η RotateLight είναι 1 περιστρέφουμε το φως
int RotateLight = 0;
//Αν είναι η ModelID είναι 1 απεικονίζουμε το διαστημόπλοιο, αλλιως τη σφαίρα
int ModelID = 0;

// Περιστροφή αντικειμένου γύρω από τον άξονα X και Y
static GLfloat xRot = -90.0f;
static GLfloat yRot = 0.0f;

//γωνία περιστροφής του φωτός
GLfloat LightAngle = 0.0f;

//αρχική θέση του φωτός. 
GLfloat	 lightPos[] = { 9.0f, 9.0f, 0.0f, 1.0f };
GLfloat    spotDir[] = { -1.0f, -1.0f, 0.0f };

//χρώματα του φωτός
GLfloat  lightAmbientColour[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat  lightDiffuseColour[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat lightSpecularColour[] = { 2.0f, 2.0f, 2.0f, 1.0f };

//χρώματα του υλικού
GLfloat  materialAmbientColour[] = { 0.2125f, 0.1275f, 0.054f, 1.0f };
GLfloat  materialDiffuseColour[] = { 0.714f, 0.4284f, 0.18144f, 1.0f };
GLfloat materialSpecularColour[] = { 0.393548f, 0.271906f, 0.166721f, 1.0f };

//obj_type object;

/*********************************************
    Συνάρτηση που σχεδιάζει τους άξονες του συστήματος
    κόσμου
*********************************************/
void drawAxis()
{
    if (DrawAxis)
    {
        //ο άξονας Χ σε κόκκινο
        glColor3f(1, 0, 0);
        glBegin(GL_LINES);
        glVertex3f(-10, 0, 0);
        glVertex3f(10, 0, 0);
        glEnd();

        //ο άξονας Υ σε πράσινο
        glColor3f(0, 1, 0);
        glBegin(GL_LINES);
        glVertex3f(0, -8, 0);
        glVertex3f(0, 8, 0);
        glEnd();

        //ο άξονας Ζ σε μπλέ 
        glColor3f(0, 0, 1);
        glBegin(GL_LINES);
        glVertex3f(0, 0, -10);
        glVertex3f(0, 0, 10);
        glEnd();
    }
}


/*********************************************
    Συνάρτηση που σχεδιάζει τα αντικείμενα
    στην οθόνη
*********************************************/
void renderScene(void)
{
    //Καθόρισε το πίνακα ModelView σαν τον ενεργό πίνακα
    glMatrixMode(GL_MODELVIEW);
    //κάνε τον ModelView ίσο με τον μοναδιαίο πίνακα
    glLoadIdentity();
    //καθόρισε που θα κοιτά η κάμερα
    gluLookAt(15, 15, 15, 0, 0, 0, 0, 1, 0);

    //απανεργοποίησε προσωρινά όλα τα φώτα
    glDisable(GL_LIGHTING);

    //καθάρισε την οθόνη
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    if (DrawAxis)
    {
        drawAxis();
    }

    // ΤΜΗΜΑ ΠΟΥ ΤΟΠΟΘΕΤΕΙ, ΠΕΡΙΣΤΡΕΦΕΙ ΚΑΙ ΖΩΓΡΑΦΙΖΕΙ ΤΟ ΦΩΣ ΣΑΝ ΣΦΑΙΡΑ *****
    glPushMatrix();
    //περίστρεψε το φως γύρω από τον Z    
    glRotatef(LightAngle, 0.0f, 0.0f, 1.0f);
    //έλεγξε άν πρέπει να αλλάξουμε την γωνία περιστροφής του φωτός    
    if (RotateLight)
    {
        LightAngle += 0.1;
    }
    //ζωγράφισε το φως σαν μια κίτρινη σφαίρα
    glColor3f(1, 1, 0);
    //ο λόγος που χρησιμοποιώ την glPushMatrix εδώ είναι γιατί δεν θέλω η μετακίνηση
    //της σφαίρας να εφαρμοστεί και στην πραγματική θέση φωτός
    glPushMatrix();
    //μετακίνησε τη σφαίρα στην σωστή τοποθεσία 
    glTranslatef(lightPos[0], lightPos[1], lightPos[2]);
    glutSolidSphere(0.3, 10, 10);
    glPopMatrix();

    //τοποθέτησε το πραγματικό φως στην σωστή θέση
    glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

    glPopMatrix();

    // ΤΜΗΜΑ ΠΟΥ ΤΟΠΟΘΕΤΕΙ, ΠΕΡΙΣΤΡΕΦΕΙ ΚΑΙ ΖΩΓΡΑΦΙΖΕΙ TO ΜΟΝΤΕΛΟ *****     
    //ενεργοποίησε όλα τα φώτα
    glEnable(GL_LIGHTING);

    //περίστρεψε το αντικείμενο γύρω απο τον X και Y ανάλογα με την 
    //γωνία που έχει καθορίσει ο χρήστης.
    glRotatef(xRot, 1.0f, 0.0f, 0.0f);
    glRotatef(yRot, 0.0f, 1.0f, 0.0f);

    glScalef(0.3, 0.3, 0.3);
    //επέλεξε τι θα ζωγραφίσουμε
    if (ModelID == 1)
    {
        //ζωγράφισε το μοντέλο του διαστημοπλοίου
        //renderModel(object);
    }
    else
    {
        //ζωγράφισε την σφαίρα
        glutSolidSphere(15.0, 20, 20);
    }

    glutSwapBuffers();
}

/*********************************************
    Συνάρτηση που θα καλεστεί όταν ο χρήστης
    πατήσει ένα πλήκτρο στο πληκτρολογιο
*********************************************/
void keyPress(unsigned char key, int x, int y)
{
    switch (key)
    {
        //έλεγξε αν ο χρήστης έχει πατήσει τα πλήκτρα 'ΕSC' ή 'q'        
    case 27:
    case 'q':
        //έχει πατήσει κάποιο από τα δυο πλήκτρα, έξοδος από το πρόγραμμα
        exit(0);
        break;
    case 'a':
    case 'A':
        DrawAxis = 1 - DrawAxis;
        break;
    case 'm':
    case 'M':
        //αποφασίζει αν θα ζωγραφίσουμε σφαίρα ή διαστημόπλοιο
        ModelID = 1 - ModelID;
        break;
    case 32:
        //ξεκινά και σταματά την περιστροφή του φωτός
        RotateLight = 1 - RotateLight;
        break;

    }

    glutPostRedisplay();
}

/*********************************************
    Συνάρτηση που θα καλεστεί όταν ο χρήστης
    πατήσει κάποιο ειδικό πλήκτρο (CTRL, SHIFT, cursor keys)
    στο πληκτρολογιο
*********************************************/
void specialKeyPress(int key, int x, int y)
{
    switch (key)
    {
    case GLUT_KEY_UP:
        xRot -= 5.0f;
        break;
    case GLUT_KEY_DOWN:
        xRot += 5.0f;
        break;
    case GLUT_KEY_LEFT:
        yRot -= 5.0f;
        break;
    case GLUT_KEY_RIGHT:
        yRot += 5.0f;
        break;
    }
    glutPostRedisplay();
}

/*********************************************
    Αρχικοποίηση της εφαρμογής. Εδώ εκτελούμε
    εντολές που πρέπει να τρέξουν μία μόνο φορά
*********************************************/
void init(void)
{
    float fAspect = ((float)Width) / Height;
    //Καθορισμός χρώματος στο οποίο θα καθαρίζεται το παράθυρο
    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

    //καθορισμός ενεργού πίνακα. Οτι μετασχηματισμούς εφαρμόσουμε τώρα
    //θα επηρεάσουν τον πίνακα προβολής
    glMatrixMode(GL_PROJECTION);
    //κάνε τον πίνακα προβολής ίσο με τον μοναδιαίο πίνακα
    glLoadIdentity();
    //όρισε μια προβολή με προοπτική.
    gluPerspective(45.0f, fAspect, 1.0, 400.0);

    //Load3DS(&object, "fighter/fighter1.3ds");

    glEnable(GL_CULL_FACE);
    glFrontFace(GL_CCW);
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);

    //η εντολή αυτή αναγκάζει την OpenGL να ξανα-κανονικοποιήσει ta
    //κανονικά διανύσματα (normals) της γεωμετρίας
    glEnable(GL_NORMALIZE);

    //όρισε τον έμμεσο (ambient) φωτισμό στην σκηνή
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lightAmbientColour);

    //δημιούργησε ένα φως
    glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuseColour);

    //ενεργοποίησε το
    glEnable(GL_LIGHT0);

    //δημιούργησε ένα υλικό για τα αντικείμενα που θα απεικονίσουμε
    glMaterialfv(GL_FRONT, GL_AMBIENT, materialAmbientColour);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, materialDiffuseColour);

    //επέλεξε μέθοδο χρωματισμού GL_FLAT ή GL_SMOOTH (Gouraud)
    glShadeModel(GL_FLAT);
}

/*********************************************
     Αρχική συνάρτηση. Με αυτή τη συνάρτηση θα αρχίζει πάντα
     η εκτέλεση του προγράμματος
*********************************************/
int main(int argc, char* argv[])
{
    //αρχικοποίηση GLUT
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);

    //δημιουργία παραθύρου στο οποίο θα δείξουμε την εικόνα
    glutInitWindowSize(Width, Height);
    glutInitWindowPosition(150, 150);
    glutCreateWindow("Computer Graphics - Lab 3");

    //καθορισμός συνάρτησης που θα καλείται σε περίπτωση που το παράθυρο χρειάζεται 
    //επανασχεδίαση
    glutDisplayFunc(renderScene);

    //καθορισμός συνάρτησης που παρακολουθεί την είσοδο από το πληκτρολόγιο
    glutKeyboardFunc(keyPress);
    //καθορισμός συνάρτησης που ελέγχει το πληκτρολόγιο για τα cursor keys
    glutSpecialFunc(specialKeyPress);

    //καθορισμός συνάρτησης που θα καλείται όταν to GLUT δεν εξυπηρετεί κάποιο συμβάν.
    glutIdleFunc(renderScene);

    init();

    glutMainLoop();

    return EXIT_SUCCESS;
}

